import greenfoot.*;
public class PacMan extends SmoothMover
{
    private int img_timer = 0;
    private int direction = 0;
    private int stop = 0;
    private int tot = -1;
    
    private Welt welt;
    
    public void setWelt(Welt w) {welt = w;}
    
    
    public PacMan()
    {
        setImage(welt.img_Pacman[0]);
    }
    
    public void kill() {tot=0;}
    public boolean amLeben() {return tot==-1;}
    
    public void act()
    {
        if (!welt.gestartet()) return;
        
        if (tot > -1)
        {
            setRotation(0);
            setImage(Welt.img_Pacman_tot[Math.min(tot/7, 13)]);
            tot++;
            if (tot == 7*14)
            {
                welt.addFade(false);
            }
            return;
        }
        
        
        if (stop > 0)
        {
            stop--;
            return;
        }
        
        checkKeys();
        
        Punkt p = (Punkt) getOneIntersectingObject(Punkt.class);
        if (p != null)
        {
            if (welt.essen(p))
            {
                stop = 1;
            }
            else
            {
                stop = 3;
            }
        }
        
        Frucht f = (Frucht) getOneIntersectingObject(Frucht.class);
        if (f != null)
        {
            welt.essen(f);
        }
    }
    
    private void checkKeys()
    {
        int dx=0, dy=0;
        if (Greenfoot.isKeyDown("up")) dy--;
        if (Greenfoot.isKeyDown("right")) dx++;
        if (Greenfoot.isKeyDown("down")) dy++;
        if (Greenfoot.isKeyDown("left")) dx--;
        if (dx==0 && dy==0)
        {
            setImage(welt.img_Pacman[2]);
            /*if (getX()%8==4 && getY()%8==4)*/ return;
            /*else
            {
                switch (direction)
                {
                    case 0: dx=1; break;
                    case 1: dy=1; break;
                    case 2: dx=-1; break;
                    case 3: dy=-1; break;
                }
            }*/
        }
        //System.out.println(getRotation() + "--" + getX() + "--" + dx + "--" + welt.getPacSpeed());
        //turnTowards(getX()+dx, getY()+dy);
        //move(welt.getPacSpeed());
        //System.out.println(getRotation() + "--" + getX() + "--" + dx + "--" + welt.getPacSpeed());
        
        //if (wand())
        //{
            //move(-welt.getPacSpeed());
            if (dx == 0 || dy == 0)
            {
                turnTowards(getX()+dx, getY()+dy);
                move(welt.getPacSpeed());
                if (wand())
                {
                    move(-welt.getPacSpeed());
                }
            }
            else
            {
                turnTowards(getX()+dx*direction%2, getY()+dy*(direction+1)%2);
                move(welt.getPacSpeed());
                if (wand())
                {
                    move(-welt.getPacSpeed());
                    turnTowards(getX()+dx*(direction+1)%2, getY()+dy*direction%2);
                    move(welt.getPacSpeed());
                    if (wand()) move(-welt.getPacSpeed());
                }
            }
        //}
        changeImage();
        setRotation(getRotation()-getRotation()%90);
        direction = (getRotation()/90)%4;
        int w = getWorld().getWidth();
        setLocation((getExactX()+w)%w, getExactY());
    }
    
    private boolean wand()
    {
        int w = getWorld().getWidth();
        for (int i=-3; i<4; i++) for (int j=-3; j<4; j++)
        {
            int x = getX()+j, y = getY()+i;
            x = (x+w)%w;
            x /= 8;
            y /= 8;
            if (welt.wand(x, y)) return true;
        }
        return false;
    }
    
    
    private void changeImage()
    {
        img_timer = (img_timer + 1) % 8;
        setImage(welt.img_Pacman[Math.abs(img_timer-(2*(img_timer%4)))]);
    }
    
    
    public int getDir() {return direction;}
}