import greenfoot.*;

public class StartWorld extends World
{
    private Actor[] buttons = new Button[5];
    
    public StartWorld()
    {
        super(Welt.x, Welt.y, 1);
        Welt.sizeFactor = 1;
        createImage();
        Greenfoot.getKey();
        Greenfoot.start();
    }
    
    public void act()
    {
        boolean start = false;
        
        String key = Greenfoot.getKey();
        if (key != null)
        {
            switch (key)
            {
                case "1": Welt.sizeFactor = 1; start = true; break;
                case "2": Welt.sizeFactor = 2; start = true; break;
                case "3": Welt.sizeFactor = 3; start = true; break;
                case "4": Welt.sizeFactor = 4; start = true; break;
                case "5": Welt.sizeFactor = 5; start = true; break;
            }
        }
        
        if (!start)
        {
            for (int i=0; i<5; i++)
            {
                if (Greenfoot.mousePressed(buttons[i]))
                {
                    Welt.sizeFactor = i+1;
                    start = true;
                    break;
                }
            }
        }
        
        
        if (start) Greenfoot.setWorld(new Welt());
    }
    
    private void createImage()
    {
        GreenfootImage img = new GreenfootImage(getWidth(), getHeight());
        img.setColor(Color.BLACK);
        img.fill();
        img.setColor(Color.YELLOW);
        img.setFont(new Font("Calibri", false, false, 15));
        img.drawString("    Select the size for the game.\n          The size is the number\n         multiplied with the size\n          of the current window.\n       Press Escape to come back\n          to this screen if needed.", getWidth()/2-100, getHeight()/6);
        
        for (int i=0; i<5; i++)
        {
            //img.drawImage(new GreenfootImage("" + (i+1), 15, new Color(255, 0, 0), new Color(0,0,0,0)), getWidth()/2-5, getHeight()/2+i*20);
            addObject(buttons[i] = new Button(i), getWidth()/2, getHeight()/2+20+i*25);
        }
        setBackground(img);
    }
    
    private class Button extends Actor
    {
        public Button(int i)
        {
            GreenfootImage img = new GreenfootImage(70, 20);
            img.setColor(Color.ORANGE);
            img.fillOval(0, 0, img.getHeight()-1, img.getHeight()-1);
            img.fillOval(img.getWidth()-img.getHeight(), 0, img.getHeight()-1, img.getHeight()-1);
            img.fillRect(img.getHeight()/2, 0, img.getWidth()-img.getHeight(), img.getHeight());
            
            img.setColor(Color.RED);
            img.setFont(new Font("Calibri", true, false, 15));
            img.drawString(""+(i+1), img.getWidth()/2-3, 15);
            setImage(img);
        }
    }
}