import greenfoot.*;
public class Welt extends World
{
    public static int sizeFactor = 1;
    
    
    private int level = 1;
    private int leben = 3;
    private int score = 0;
    private Schrift level_counter = new Schrift(level, 0, true);
    private Leben leben_counter = new Leben();
    private Schrift score_counter = new Schrift(score, 0, true);
    
    
    private int extraLeben = 2;
    
    
    private int ende = -1; //-1 vor start, >0 wenn Spiel beendet (Game Over), 0 sonst
    
    
    private Knopf knopf = new Knopf(0);
    
    private static final double speedFactor = 0.95; //damit kein speed>1
    private static final int fpsFactor = 60;
    
    private static final double[][] pacSpeed = //ohne - mit Powerup
    {
        {0.8*speedFactor, 0.9 *speedFactor},    //Level 1
        {0.9*speedFactor, 0.95*speedFactor},    //Level 2..4
        {1*  speedFactor, 1   *speedFactor},    //Level 5..20
        {0.9*speedFactor,                 }     //Level 21+
    };
    public double getPacSpeed() {return pacSpeed[levelToStage()][(int)Math.signum(powerup)];}
    
    private static final double[][][] geistSpeed =
    {
        {{0.75*speedFactor, 0.8*speedFactor, 0.85*speedFactor}, {0.5 *speedFactor}, {0.4 *speedFactor}},    //Level 1
        {{0.85*speedFactor, 0.9*speedFactor, 0.95*speedFactor}, {0.55*speedFactor}, {0.45*speedFactor}},    //Level 2..4
        {{0.95*speedFactor, 1  *speedFactor, 1.05*speedFactor}, {0.6 *speedFactor}, {0.5 *speedFactor}},    //Level 5..20
        {{0.95*speedFactor, 1  *speedFactor, 1.05*speedFactor}, {                }, {0.5 *speedFactor}}     //Level 21+
    };    
    
    public double getGeistSpeed(Geist g) //hier mit getBlau statt powerup>0, da der Geist nach Rückkehr zum Haus wieder normal agieren soll
    {
        return !g.amLeben() ? speedFactor : geistSpeed[levelToStage()][tunnel(g) ? 2 : g.getBlau() ? 1 : 0][tunnel(g) || g.getBlau() ? 0 : g.getElroy()];
    }
    
    /*private static final int[][] heimatPos =
    {
        
    };*/
    //public double get
    
    public static final int[] powerUpZeit =
    {
        6*fpsFactor, 5*fpsFactor, 4*fpsFactor, 3*fpsFactor, 2*fpsFactor, 5*fpsFactor, 2*fpsFactor, 2*fpsFactor, 1*fpsFactor, 5*fpsFactor, 2*fpsFactor, 1*fpsFactor, 1*fpsFactor, 3*fpsFactor, 1*fpsFactor, 1*fpsFactor, 0, 1*fpsFactor, 0
    };
    
    public static final int[][] frucht = //image, score
    {
        {0, 100}, //Level 1, erstes Bild (Kirsche), 100 Punkte
        {1, 300},
        {2, 500},
        {2, 500},
        {3, 700},
        {3, 700},
        {4,1000},
        {4,1000},
        {5,2000},
        {5,2000},
        {6,3000},
        {6,3000},
        {7,5000}, //Level 13+, achtes Bild (Schlüssel), 5000 Punkte
    };
    
    
    
    //public int getDots() {return getObjects(Punkt.class).size();}
    
    private int levelToStage()
    {
        if (level==1) return 0;
        if (level<5) return 1;
        if (level<21) return 2;
        return 3;
    }
    
    /**
     * -1: Nur für Geist
     * 0: Leer
     * 1: Wand
     * 2: Dot
     * 3: PowerUp
     */
    private static final int[][] map =
    {
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
        { 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 1, 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 1},
        { 1, 2, 1, 1, 1, 1, 2, 1, 1, 1, 1, 1, 2, 1, 1, 2, 1, 1, 1, 1, 1, 2, 1, 1, 1, 1, 2, 1},
        { 1, 3, 1, 0, 0, 1, 2, 1, 0, 0, 0, 1, 2, 1, 1, 2, 1, 0, 0, 0, 1, 2, 1, 0, 0, 1, 3, 1},
        { 1, 2, 1, 1, 1, 1, 2, 1, 1, 1, 1, 1, 2, 1, 1, 2, 1, 1, 1, 1, 1, 2, 1, 1, 1, 1, 2, 1},
        { 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 1},
        { 1, 2, 1, 1, 1, 1, 2, 1, 1, 2, 1, 1, 1, 1, 1, 1, 1, 1, 2, 1, 1, 2, 1, 1, 1, 1, 2, 1},
        { 1, 2, 1, 1, 1, 1, 2, 1, 1, 2, 1, 1, 1, 1, 1, 1, 1, 1, 2, 1, 1, 2, 1, 1, 1, 1, 2, 1},
        { 1, 2, 2, 2, 2, 2, 2, 1, 1, 2, 2, 2, 2, 1, 1, 2, 2, 2, 2, 1, 1, 2, 2, 2, 2, 2, 2, 1},
        { 1, 1, 1, 1, 1, 1, 2, 1, 1, 1, 1, 1, 0, 1, 1, 0, 1, 1, 1, 1, 1, 2, 1, 1, 1, 1, 1, 1},
        { 0, 0, 0, 0, 0, 1, 2, 1, 1, 1, 1, 1, 0, 1, 1, 0, 1, 1, 1, 1, 1, 2, 1, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 1, 2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 2, 1, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 1, 2, 1, 1, 0, 1, 1, 1,-1,-1, 1, 1, 1, 0, 1, 1, 2, 1, 0, 0, 0, 0, 0},
        { 1, 1, 1, 1, 1, 1, 2, 1, 1, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 1, 1, 2, 1, 1, 1, 1, 1, 1},
        { 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0},
        { 1, 1, 1, 1, 1, 1, 2, 1, 1, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 1, 1, 2, 1, 1, 1, 1, 1, 1},
        { 0, 0, 0, 0, 0, 1, 2, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 1, 2, 1, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 1, 2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 2, 1, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 1, 2, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 1, 2, 1, 0, 0, 0, 0, 0},
        { 1, 1, 1, 1, 1, 1, 2, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 1, 2, 1, 1, 1, 1, 1, 1},
        { 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 1, 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 1},
        { 1, 2, 1, 1, 1, 1, 2, 1, 1, 1, 1, 1, 2, 1, 1, 2, 1, 1, 1, 1, 1, 2, 1, 1, 1, 1, 2, 1},
        { 1, 2, 1, 1, 1, 1, 2, 1, 1, 1, 1, 1, 2, 1, 1, 2, 1, 1, 1, 1, 1, 2, 1, 1, 1, 1, 2, 1},
        { 1, 3, 2, 2, 1, 1, 2, 2, 2, 2, 2, 2, 2, 0, 0, 2, 2, 2, 2, 2, 2, 2, 1, 1, 2, 2, 3, 1},
        { 1, 1, 1, 2, 1, 1, 2, 1, 1, 2, 1, 1, 1, 1, 1, 1, 1, 1, 2, 1, 1, 2, 1, 1, 2, 1, 1, 1},
        { 1, 1, 1, 2, 1, 1, 2, 1, 1, 2, 1, 1, 1, 1, 1, 1, 1, 1, 2, 1, 1, 2, 1, 1, 2, 1, 1, 1},
        { 1, 2, 2, 2, 2, 2, 2, 1, 1, 2, 2, 2, 2, 1, 1, 2, 2, 2, 2, 1, 1, 2, 2, 2, 2, 2, 2, 1},
        { 1, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 1, 1, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 1},
        { 1, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 1, 1, 2, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 1},
        { 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 1},
        { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}
    };
    
    
    public static GreenfootImage img_Pacman[] = new GreenfootImage[5];
    public static GreenfootImage img_Pacman_tot[] = new GreenfootImage[14];
    public static GreenfootImage img_Geist[][][] = new GreenfootImage[4][4][2]; //Farbe, Richtung, Bild
    public static GreenfootImage img_Geist_blau[] = new GreenfootImage[2];
    public static GreenfootImage img_Geist_tot[] = new GreenfootImage[4]; //Richtung
    
    public static GreenfootImage img_Frucht[] = new GreenfootImage[8];
    
    
    private PacMan pacman;
    private Geist[] geist;
    
    private int time = 0; //Zeit in diesem Level für Angriffswechsel (stoppt bei PowerUp)
    private boolean gestartet;
    private int gesammelt = 0; //Eingesammelte Punkte in diesem Level
    private int gesammeltVorTod = -1;
    private int zsls = 0; //Zeit seit letztem Sammeln
    private int powerup = 0; //falls > 0 → powerup aktiv
    private int geisterGegessen = 0;
    public int getPowerUp() {return powerup;}
    public void starten()
    {
        gestartet = true;
    }
    public boolean gestartet() {return gestartet;}
    
    
    public void resetVariablen() //wenn Level (neu)startet
    {
        time = 0;
        gesammelt = 0;
        gesammeltVorTod = -1;
        powerup = 0;
    }
    
    private static int lastSize = -1;
    public static final int x=28*8, y=36*8;
    
    public Welt()
    {
        super(x, y, sizeFactor, false); //Fade nutzt gleiche Zahlen
        Greenfoot.getKey();
        Greenfoot.start();
        setPaintOrder(Fade.class);
        /*GreenfootImage img = new GreenfootImage(getWidth(), getHeight());
        img.setColor(Color.BLACK);
        img.fill();
        //img.setColor(new Color(0,75,0));
        //for (int x=8; x<getWidth(); x+=9) img.drawLine(x,0,x,getHeight());
        //for (int y=8; y<getHeight(); y+=9) img.drawLine(0,y,getWidth(),y);
        setBackground(img);*/
        
        
        addObject(knopf, getWidth()-57, 12);
        
        
        if (lastSize != sizeFactor || img_Frucht[7] == null) createImages();
        
        GreenfootImage img = new GreenfootImage(getWidth()*sizeFactor, getHeight()*sizeFactor);
        img.setColor(Color.BLACK);
        img.fill();
        img.setColor(Color.YELLOW);
        img.setFont(new Font("Calibri", false, false, 15*sizeFactor));
        img.drawString("         Move with arrow keys\n\nCollect all the dots in each level\nwithout getting killed by ghosts\n\n             Press a key to start", (getWidth()*sizeFactor)/2-100*sizeFactor, (getHeight()*sizeFactor)/2);
        setBackground(img);
                
        //setBackground("Hintergrund.png");
        /*for (int i=0; i<img_Frucht.length; i++)
        {
            getBackground().drawImage(img_Frucht[i], 2*8+i*14, 1*8);
        }*/
        
        //createLevel(true);
        
        Geist.welt = this;
    }
    
    public void createLevel(boolean firstTime)
    {
        createMap();
        
        addActors(firstTime);
        //theoretisch false statt true, hier aber true benötigt
        Geist.geistFreilassen(true);
        if (level>1) Geist.geistFreilassen(true);
        if (level>2) Geist.geistFreilassen(true);
    }
    
    public void addActors(boolean firstTime)
    {
        removeObjects(getObjects(Frucht.class));
        removeObjects(getObjects(PacMan.class));
        removeObjects(getObjects(Geist.class));
        
        pacman = new PacMan();
        pacman.setWelt(this);
        Geist.pac = pacman;
        addObject(pacman, 14*8, 4+26*8);
        time = 0;
        
        geist = new Geist[] {new Geist(0), new Geist(1), new Geist(2), new Geist(3)};
        addObject(geist[0], 14*8, 4+14*8);
        addObject(geist[1], 14*8, 4+17*8);
        addObject(geist[2], 12*8, 4+17*8);
        addObject(geist[3], 16*8, 4+17*8);
        
        addObject(new Fade(firstTime ? 2 : 1), getWidth()/2, getHeight()/2);
    }
    
    public void addFade(boolean nextLevel)
    {
        addObject(new Fade(nextLevel ? -2 : -1), getWidth()/2, getHeight()/2);
        gestartet = false;
    }
    
    public void fadeWeg(int fade)
    {
        if (fade>0)
        {
            gestartet = true;
        }
        else if (fade==-1) //gestorben
        {
            gestartet = false;
            leben--;
            leben_counter.setVal(leben);
            if (leben > 0)
            {
                removeObject(pacman);
                for (int i=0; i<4; i++) removeObject(geist[i]);
                addActors(false);
                gesammeltVorTod = gesammelt;
            }
            else
            {
                removeObjects(getObjects(null));
                GreenfootImage img = new GreenfootImage(getWidth()*sizeFactor, getHeight()*sizeFactor);
                img.setColor(Color.BLACK);
                img.fill();
                img.setColor(Color.RED);
                img.setFont(new Font("Calibri", false, false, 30*Welt.sizeFactor));
                
                img.drawString("Game Over", img.getWidth()/2-70*Welt.sizeFactor, img.getHeight()/2);
                setBackground(img);
                addObject(knopf, getWidth()-57, 12);
                addObject(new Knopf(1), 50, 12);
                
                ende = 2;
            }
        }
        else //alle Punkte eingesammelt
        {
            level_counter.setVal(++level);
            resetVariablen();
            createLevel(false);
        }
    }
    
    public void act()
    {
        if (!gestartet)
        {
            if (ende < 0)
            {
                String key = Greenfoot.getKey();
                if (key != null)
                {
                    if ("escape".equals(key))
                    {
                        Greenfoot.setWorld(new StartWorld());
                        return;
                    }
                    
                    /** START THE GAME */
                    leben_counter.setVal(leben);
                    removeObject(knopf);
                    ende = 0;
                    createLevel(true);
                    GreenfootImage img = new GreenfootImage("Hintergrund.png");
                    img.scale(img.getWidth()*sizeFactor, img.getHeight()*sizeFactor);
                    setBackground(img);
                    addObject(score_counter, getWidth()-score_counter.getImage().getWidth()/2/sizeFactor-10, score_counter.getImage().getHeight()/sizeFactor);
                    addObject(level_counter, getWidth()/8-level_counter.getImage().getWidth()/2/sizeFactor, level_counter.getImage().getHeight()/sizeFactor);
                    addObject(leben_counter, getWidth()/3-leben_counter.getImage().getWidth()/2/sizeFactor, getHeight()+5-leben_counter.getImage().getHeight()/sizeFactor);
                    
                    return;
                }
            }
            
            
            if (ende > 0)
            {
                if (--ende == 1)
                {
                    if (UserInfo.isStorageAvailable())
                    {
                        UserInfo me = UserInfo.getMyInfo();
                        if (score > me.getInt(0)) me.setInt(0, score);
                        if (level > me.getInt(1)) me.setInt(1, level);
                        me.store();
                    }
                }
                
                else if (ende == 0)
                {
                    Greenfoot.getKey(); // → um sofortigen Neustart zu verhindern
                    //Greenfoot.setWorld(new Welt());
                    
                }
            }
            return;
        }
        
        
        for (Geist g : geist)
        {
            if (g.getX()/8 == pacman.getX()/8 && g.getY()/8 == pacman.getY()/8)
            {
                if (g.getBlau())
                {
                    g.kill();
                    int toAdd = 200*(int)Math.pow(2, geisterGegessen++);
                    score += toAdd;
                    score_counter.setVal(score);
                    addObject(new Schrift(toAdd, 2*fpsFactor, false), g.getX(), g.getY());
                    
                    if (extraLeben==2 && score>10000 || extraLeben==1 && score>100000)
                    {
                        extraLeben--;
                        leben++;
                        leben_counter.setVal(leben);
                    }
                }
                else if (g.amLeben() && pacman.amLeben())
                {
                    pacman.kill();
                }
            }
        }
        
        
        if (powerup>0)
        {
            if (--powerup==0)
            {
                for (Geist g : geist)
                {
                    g.setBlau(-1);
                }
            }
        }
        else
        {
            time++;
        
            if (level==1)
            {
                if (++zsls==fpsFactor*5) {Geist.geistFreilassen(false); zsls=0;}
                
                switch (time)
                {
                    case 7*fpsFactor: case 27*fpsFactor: case 34*fpsFactor: case 54*fpsFactor: case 59*fpsFactor: case 79*fpsFactor: case 84*fpsFactor:
                        wechsel(); break;
                }
            }
            else if (level<5)
            {
                if (++zsls==fpsFactor*5) {Geist.geistFreilassen(false); zsls=0;}
                
                switch (time)
                {
                    case 7*fpsFactor: case 27*fpsFactor: case 34*fpsFactor: case 54*fpsFactor: case 59*fpsFactor: case 1092*fpsFactor: case 1092*fpsFactor+1:
                    wechsel(); break;
                }
            }
            else
            {
                if (++zsls==fpsFactor*4) {Geist.geistFreilassen(false); zsls=0;}
                
                switch (time)
                {
                    case 5*fpsFactor: case 25*fpsFactor: case 30*fpsFactor: case 50*fpsFactor: case 60*fpsFactor: case 1092*fpsFactor: case 1092*fpsFactor+1:
                    wechsel(); break;
                }
            }
        
        }
    }
    
    private void wechsel()
    {
        for (Geist g : geist)
        {
            g.wechselModus();
        }
    }
    
    public boolean essen(Punkt p)
    {
        removeObject(p);
        gesammelt++; zsls=0;
        
        if (gesammelt==244) addFade(true);
        
        
        if (level==1 && (gesammelt==30 || gesammelt==90)
        || level==2 && gesammelt==50)
        {
            Geist.geistFreilassen(true);
        }
        
        
        if (level==1 && (gesammelt==224 || gesammelt==234)
         || level==2 && (gesammelt==214 || gesammelt==239)
         || (level==3 || level==4 || level==5) && (gesammelt==204 || gesammelt==224)
         || (level==6 || level==7 || level==8) && (gesammelt==194 || gesammelt==219)
         || (level==9 || level==10 || level==11) && (gesammelt==184 || gesammelt==214)
         || (level==12 || level==13 || level==14) && (gesammelt==164 || gesammelt==204)
         || (level==15 || level==16 || level==17 || level==18) && (gesammelt==144 || gesammelt==194)
         || level>18 && (gesammelt==124 || gesammelt==184))
        {
            geist[0].elroy();
        }
        
        if (gesammeltVorTod != -1)
        {
            if (gesammelt-gesammeltVorTod==7 || gesammelt-gesammeltVorTod==17 || gesammelt-gesammeltVorTod==32)
            {
                Geist.geistFreilassen(true);
            }
        }
        
        
        if (!p.getKlein())
        {
            score += 50;
            powerup = powerUpZeit[Math.min(level-1, 18)];
            for (Geist g : geist)
            {
                g.setBlau(powerup);
            }
            geisterGegessen = 0;
        }
        else score += 10;
        score_counter.setVal(score);
        
        
        if (gesammelt == 70 || gesammelt == 170)
        {
            Actor f = new Frucht();
            addObject(f, 14*8, 20*8+4);
            f.setImage(img_Frucht[frucht[Math.min(12,level-1)][0]]);
        }
        
        if (extraLeben==2 && score>10000 || extraLeben==1 && score>100000)
        {
            extraLeben--;
            leben++;
            leben_counter.setVal(leben);
        }
        
        return p.getKlein();
    }
    
    public void essen(Frucht f)
    {
        score += frucht[Math.min(12,level-1)][1];
        score_counter.setVal(score);
        
        addObject(new Schrift(frucht[Math.min(12,level-1)][1], 2*fpsFactor, false), f.getX(), f.getY());
        removeObject(f);
    }
    
    
    public boolean wand(int x, int y) {return map[(y+36)%36][(x+28)%28]==1 || map[(y+36)%36][(x+28)%28]==-1;}
    public boolean wand(int x, int y, boolean tot) {return tot ? map[(y+36)%36][(x+28)%28]==1 : wand(x,y);}
    
    public PacMan getPac() {return pacman;}
    public Geist getGeist(int i) {return geist[i];}
    
    
    /** true, falls Actor a im Tunnel (links oder rechts in der Nähe des Rands) */
    public static boolean tunnel(Actor a)
    {
        int x = a.getX()/8;
        return a.getY()/8==17 && (x==0 || x==1 || x==2 || x==3 || x==24 || x==25 || x==26 || x==27);
    }
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    private void createImages()
    {
        Color c = new Color(255, 255, 0);
        
        int k=0; //Hilfsvariable -- Zeile in der gerade gemalt wird
        
        //nach rechts
        for (int i=0; i<img_Pacman.length; i++)
        {
            img_Pacman[i] = new GreenfootImage(13*sizeFactor,13*sizeFactor);
            img_Pacman[i].setColor(c);//beide Zeilen oben und unten bei allen 5 Bildern identisch
            
            drawLine(img_Pacman[i], 5,0,7,0);
            drawLine(img_Pacman[i], 3,1,9,1);
            drawLine(img_Pacman[i], 3,11,9,11);
            drawLine(img_Pacman[i], 5,12,7,12);
            
            
            switch (i)
            {
                case 0: //Kreis
                drawLine(img_Pacman[i], 0,5,0,7);
                drawLine(img_Pacman[i], 1,3,1,9);
                drawLine(img_Pacman[i], 11,3,11,9);
                drawLine(img_Pacman[i], 12,5,12,7);
                fillRect(img_Pacman[i], 2,2,9,9);
                break;
                
                case 1: //winziger Mund
                k=2;
                drawLine(img_Pacman[i], 2,k,10,k); k++;
                drawLine(img_Pacman[i], 1,k,11,k); k++;
                drawLine(img_Pacman[i], 1,k,11,k); k++;
                drawLine(img_Pacman[i], 0,k,9,k); k++;
                drawLine(img_Pacman[i], 0,k,7,k); k++;
                drawLine(img_Pacman[i], 0,k,9,k); k++;
                drawLine(img_Pacman[i], 1,k,11,k); k++;
                drawLine(img_Pacman[i], 1,k,11,k); k++;
                drawLine(img_Pacman[i], 2,k,10,k);
                break;
                
                case 2: //kleiner Mund
                k=2;
                drawLine(img_Pacman[i], 2,k,10,k); k++;
                drawLine(img_Pacman[i], 1,k,10,k); k++;
                drawLine(img_Pacman[i], 1,k,9,k); k++;
                drawLine(img_Pacman[i], 0,k,7,k); k++;
                drawLine(img_Pacman[i], 0,k,6,k); k++;
                drawLine(img_Pacman[i], 0,k,7,k); k++;
                drawLine(img_Pacman[i], 1,k,9,k); k++;
                drawLine(img_Pacman[i], 1,k,10,k); k++;
                drawLine(img_Pacman[i], 2,k,10,k);
                break;
                
                case 3: //großer Mund
                k=2;
                drawLine(img_Pacman[i], 2,k,10,k); k++;
                drawLine(img_Pacman[i], 1,k,9,k); k++;
                drawLine(img_Pacman[i], 1,k,7,k); k++;
                drawLine(img_Pacman[i], 0,k,5,k); k++;
                drawLine(img_Pacman[i], 0,k,4,k); k++;
                drawLine(img_Pacman[i], 0,k,5,k); k++;
                drawLine(img_Pacman[i], 1,k,7,k); k++;
                drawLine(img_Pacman[i], 1,k,9,k); k++;
                drawLine(img_Pacman[i], 2,k,10,k);
                break;
                
                case 4: //riesiger Mund
                k=2;
                drawLine(img_Pacman[i], 2,k,8,k); k++;
                drawLine(img_Pacman[i], 1,k,7,k); k++;
                drawLine(img_Pacman[i], 1,k,6,k); k++;
                drawLine(img_Pacman[i], 0,k,5,k); k++;
                drawLine(img_Pacman[i], 0,k,4,k); k++;
                drawLine(img_Pacman[i], 0,k,5,k); k++;
                drawLine(img_Pacman[i], 1,k,6,k); k++;
                drawLine(img_Pacman[i], 1,k,7,k); k++;
                drawLine(img_Pacman[i], 2,k,8,k);
                break;
            }
        }
        
        //gestorbener Pacman
        //nach rechts
        for (int i=0; i<img_Pacman_tot.length; i++)
        {
            k=12;
            
            img_Pacman_tot[i] = new GreenfootImage(13*sizeFactor,13*sizeFactor);
            if (i==13) continue;
            
            img_Pacman_tot[i].setColor(c);
            
            drawLine(img_Pacman_tot[i], 5,k,7,k); k--; //11
            
            if (i<11) drawLine(img_Pacman_tot[i], 3,k,9,k);
            else if (i==11) drawLine(img_Pacman_tot[i], 4,k,8,k);
            else drawLine(img_Pacman_tot[i], 5,k,7,k);
            k--; //10
            
            if (i<10) drawLine(img_Pacman_tot[i], 2,k,10,k);
            else if (i==10) drawLine(img_Pacman_tot[i], 3,k,9,k);
            else if (i==11) drawLine(img_Pacman_tot[i], 4,k,8,k);
            else drawLine(img_Pacman_tot[i], 5,k,7,k);
            k--; //9
            
            if (i<9) drawLine(img_Pacman_tot[i], 1,k,11,k);
            else if (i==9) drawLine(img_Pacman_tot[i], 2,k,10,k);
            else if (i==10) drawLine(img_Pacman_tot[i], 4,k,8,k);
            else if (i==11) drawLine(img_Pacman_tot[i], 5,k,7,k);
            else drawLine(img_Pacman_tot[i], 6,k,6,k);
            k--; //8
            
            if (i<8) drawLine(img_Pacman_tot[i], 1,k,11,k);
            else if (i==8) drawLine(img_Pacman_tot[i], 3,k,9,k);
            else if (i==9) drawLine(img_Pacman_tot[i], 4,k,8,k);
            else if (i==10) drawLine(img_Pacman_tot[i], 5,k,7,k);
            else {drawLine(img_Pacman_tot[i], 6,k,6,k); continue;}
            k--; //7
            
            if (i<8) drawLine(img_Pacman_tot[i], 0,k,12,k);
            else {drawLine(img_Pacman_tot[i], 6,k,6,k); continue;}
            if (i==7) continue;
            k--; //6
            
            drawLine(img_Pacman_tot[i], 0,k,12,k);
            if (i==6) continue;
            k--; //5
            
            if (i<3) drawLine(img_Pacman_tot[i], 0,k,12,k);
            else {drawLine(img_Pacman_tot[i], 0,k,5,k); drawLine(img_Pacman_tot[i], 7,k,12,k);}
            k--; //4;
            
            if (i==0) drawLine(img_Pacman_tot[i], 1,k,11,k);
            else if (i<3) {drawLine(img_Pacman_tot[i], 1,k,5,k); drawLine(img_Pacman_tot[i], 7,k,11,k);}
            else if (i==3) {drawLine(img_Pacman_tot[i], 1,k,4,k); drawLine(img_Pacman_tot[i], 8,k,11,k);}
            else if (i==4) {drawLine(img_Pacman_tot[i], 1,k,3,k); drawLine(img_Pacman_tot[i], 9,k,11,k);}
            else {drawLine(img_Pacman_tot[i], 1,k,2,k); drawLine(img_Pacman_tot[i], 10,k,11,k); continue;}
            k--; //3
            
            if (i==0) drawLine(img_Pacman_tot[i], 1,k,11,k);
            else if (i==1) {drawLine(img_Pacman_tot[i], 1,k,5,k); drawLine(img_Pacman_tot[i], 7,k,11,k);}
            else if (i==2) {drawLine(img_Pacman_tot[i], 1,k,4,k); drawLine(img_Pacman_tot[i], 8,k,11,k);}
            else if (i==3) {drawLine(img_Pacman_tot[i], 1,k,3,k); drawLine(img_Pacman_tot[i], 9,k,11,k);}
            else {drawLine(img_Pacman_tot[i], 1,k,1,k); drawLine(img_Pacman_tot[i], 11,k,11,k); continue;}
            k--; //2
            
            if (i==0) drawLine(img_Pacman_tot[i], 2,k,10,k);
            else if (i==1) {drawLine(img_Pacman_tot[i], 2,k,4,k); drawLine(img_Pacman_tot[i], 8,k,10,k);}
            else if (i==2) {drawLine(img_Pacman_tot[i], 2,k,3,k); drawLine(img_Pacman_tot[i], 9,k,10,k);}
            else {drawLine(img_Pacman_tot[i], 2,k,2,k); drawLine(img_Pacman_tot[i], 10,k,10,k); continue;}
            k--; //1
            
            if (i==0) drawLine(img_Pacman_tot[i], 3,k,9,k);
            else if (i==1) {drawLine(img_Pacman_tot[i], 3,k,4,k); drawLine(img_Pacman_tot[i], 8,k,9,k); continue;}
            else {drawLine(img_Pacman_tot[i], 3,k,3,k); drawLine(img_Pacman_tot[i], 9,k,9,k); continue;}
            k--; //0
            
            drawLine(img_Pacman_tot[i], 5,k,7,k);
        }
        
        
        
        //Geister
        
        for (int h=0; h<img_Geist[0][0].length; h++) for (int i=0; i<img_Geist[0].length; i++) for (int j=0; j<img_Geist.length; j++)
        {
            k = 0;
            img_Geist[j][i][h] = new GreenfootImage(14*sizeFactor,14*sizeFactor);
            
            switch(j) //Farbe verschieden
            {
                case 0: c = new Color(255, 0, 0); break; //rot
                case 1: c = new Color(255, 184, 255); break; //pink
                case 2: c = new Color(0, 255, 255); break; //hellblau
                case 3: c = new Color(255, 184, 81); break; //ocker
            }
            img_Geist[j][i][h].setColor(c);
            
            
            drawLine(img_Geist[j][i][h], 5,k,8,k); k++;
            drawLine(img_Geist[j][i][h], 3,k,10,k); k++;
            drawLine(img_Geist[j][i][h], 2,k,11,k); k++;
            drawLine(img_Geist[j][i][h], 1,k,12,k); k++;
            drawLine(img_Geist[j][i][h], 1,k,12,k); k++;
            drawLine(img_Geist[j][i][h], 1,k,12,k); k++;
            drawLine(img_Geist[j][i][h], 0,k,13,k); k++;
            drawLine(img_Geist[j][i][h], 0,k,13,k); k++;
            drawLine(img_Geist[j][i][h], 0,k,13,k); k++;
            drawLine(img_Geist[j][i][h], 0,k,13,k); k++;
            drawLine(img_Geist[j][i][h], 0,k,13,k); k++;
            drawLine(img_Geist[j][i][h], 0,k,13,k); k++;
            
            switch (h) //unten verschieden
            {
                case 0:
                drawLine(img_Geist[j][i][h], 0,k,1,k);
                drawLine(img_Geist[j][i][h], 3,k,5,k);
                drawLine(img_Geist[j][i][h], 8,k,10,k);
                drawLine(img_Geist[j][i][h], 12,k,13,k);
                k++;
                drawLine(img_Geist[j][i][h], 0,k,0,k);
                drawLine(img_Geist[j][i][h], 4,k,5,k);
                drawLine(img_Geist[j][i][h], 8,k,9,k);
                drawLine(img_Geist[j][i][h], 13,k,13,k);
                break;
                
                case 1:
                drawLine(img_Geist[j][i][h], 0,k,3,k);
                drawLine(img_Geist[j][i][h], 5,k,8,k);
                drawLine(img_Geist[j][i][h], 10,k,13,k);
                k++;
                drawLine(img_Geist[j][i][h], 1,k,2,k);
                drawLine(img_Geist[j][i][h], 6,k,7,k);
                drawLine(img_Geist[j][i][h], 11,k,12,k);
                break;
            }
            
            img_Geist[j][i][h].setColor(new Color(222, 222, 255)); //weiß
            switch (i) //Augen verschieden
            {
                case 0: //nach rechts
                k = 3;
                drawLine(img_Geist[j][i][h], 4,k,5,k); drawLine(img_Geist[j][i][h], 10,k,11,k); k++;
                drawLine(img_Geist[j][i][h], 3,k,6,k); drawLine(img_Geist[j][i][h], 9,k,12,k); k++;
                drawLine(img_Geist[j][i][h], 3,k,6,k); drawLine(img_Geist[j][i][h], 9,k,12,k); k++;
                drawLine(img_Geist[j][i][h], 3,k,6,k); drawLine(img_Geist[j][i][h], 9,k,12,k); k++;
                drawLine(img_Geist[j][i][h], 4,k,5,k); drawLine(img_Geist[j][i][h], 10,k,11,k);
                img_Geist[j][i][h].setColor(new Color(33, 33, 255)); //blau
                k=5;
                drawLine(img_Geist[j][i][h], 5,k,6,k); drawLine(img_Geist[j][i][h], 11,k,12,k); k++;
                drawLine(img_Geist[j][i][h], 5,k,6,k); drawLine(img_Geist[j][i][h], 11,k,12,k);
                break;
                
                
                case 1: //nach unten
                k = 4;
                drawLine(img_Geist[j][i][h], 3,k,4,k); drawLine(img_Geist[j][i][h], 9,k,10,k); k++;
                drawLine(img_Geist[j][i][h], 2,k,5,k); drawLine(img_Geist[j][i][h], 8,k,11,k); k++;
                drawLine(img_Geist[j][i][h], 2,k,5,k); drawLine(img_Geist[j][i][h], 8,k,11,k); k++;
                drawLine(img_Geist[j][i][h], 2,k,5,k); drawLine(img_Geist[j][i][h], 8,k,11,k); k++;
                drawLine(img_Geist[j][i][h], 3,k,4,k); drawLine(img_Geist[j][i][h], 9,k,10,k);
                img_Geist[j][i][h].setColor(new Color(33, 33, 255)); //blau
                k = 7;
                drawLine(img_Geist[j][i][h], 3,k,4,k); drawLine(img_Geist[j][i][h], 9,k,10,k); k++;
                drawLine(img_Geist[j][i][h], 3,k,4,k); drawLine(img_Geist[j][i][h], 9,k,10,k);
                break;
                
                
                case 2: //nach links
                k = 3;
                drawLine(img_Geist[j][i][h], 2,k,3,k); drawLine(img_Geist[j][i][h], 8,k,9,k); k++;
                drawLine(img_Geist[j][i][h], 1,k,4,k); drawLine(img_Geist[j][i][h], 7,k,10,k); k++;
                drawLine(img_Geist[j][i][h], 1,k,4,k); drawLine(img_Geist[j][i][h], 7,k,10,k); k++;
                drawLine(img_Geist[j][i][h], 1,k,4,k); drawLine(img_Geist[j][i][h], 7,k,10,k); k++;
                drawLine(img_Geist[j][i][h], 2,k,3,k); drawLine(img_Geist[j][i][h], 8,k,9,k); k++;
                img_Geist[j][i][h].setColor(new Color(33, 33, 255)); //blau
                k = 5;
                drawLine(img_Geist[j][i][h], 1,k,2,k); drawLine(img_Geist[j][i][h], 7,k,8,k); k++;
                drawLine(img_Geist[j][i][h], 1,k,2,k); drawLine(img_Geist[j][i][h], 7,k,8,k);
                break;
                
                
                case 3: //nach oben
                k = 1;
                drawLine(img_Geist[j][i][h], 3,k,4,k); drawLine(img_Geist[j][i][h], 9,k,10,k); k++;
                drawLine(img_Geist[j][i][h], 2,k,5,k); drawLine(img_Geist[j][i][h], 8,k,11,k); k++;
                drawLine(img_Geist[j][i][h], 2,k,5,k); drawLine(img_Geist[j][i][h], 8,k,11,k); k++;
                drawLine(img_Geist[j][i][h], 2,k,5,k); drawLine(img_Geist[j][i][h], 8,k,11,k); k++;
                drawLine(img_Geist[j][i][h], 3,k,4,k); drawLine(img_Geist[j][i][h], 9,k,10,k);
                img_Geist[j][i][h].setColor(new Color(33, 33, 255)); //blau
                k = 1;
                drawLine(img_Geist[j][i][h], 3,k,4,k); drawLine(img_Geist[j][i][h], 9,k,10,k); k++;
                drawLine(img_Geist[j][i][h], 3,k,4,k); drawLine(img_Geist[j][i][h], 9,k,10,k);
                break;
            }
        }
        
        
        //Geist in blau
        for (int h=0; h<img_Geist_blau.length; h++)
        {
            k = 0;
            img_Geist_blau[h] = new GreenfootImage(14*sizeFactor,14*sizeFactor);
            
            c = new Color(33, 33, 255); //blau
            
            img_Geist_blau[h].setColor(c);
            
            
            fillRect(img_Geist_blau[h], 5,k,8,k); k++;
            drawLine(img_Geist_blau[h], 3,k,10,k); k++;
            drawLine(img_Geist_blau[h], 2,k,11,k); k++;
            drawLine(img_Geist_blau[h], 1,k,12,k); k++;
            drawLine(img_Geist_blau[h], 1,k,12,k); k++;
            drawLine(img_Geist_blau[h], 1,k,12,k); k++;
            drawLine(img_Geist_blau[h], 0,k,13,k); k++;
            drawLine(img_Geist_blau[h], 0,k,13,k); k++;
            drawLine(img_Geist_blau[h], 0,k,13,k); k++;
            drawLine(img_Geist_blau[h], 0,k,13,k); k++;
            drawLine(img_Geist_blau[h], 0,k,13,k); k++;
            drawLine(img_Geist_blau[h], 0,k,13,k); k++;
            
            switch (h) //unten verschieden
            {
                case 0:
                drawLine(img_Geist_blau[h], 0,k,1,k);
                drawLine(img_Geist_blau[h], 3,k,5,k);
                drawLine(img_Geist_blau[h], 8,k,10,k);
                drawLine(img_Geist_blau[h], 12,k,13,k);
                k++;
                drawLine(img_Geist_blau[h], 0,k,0,k);
                drawLine(img_Geist_blau[h], 4,k,5,k);
                drawLine(img_Geist_blau[h], 8,k,9,k);
                drawLine(img_Geist_blau[h], 13,k,13,k);
                break;
                
                case 1:
                drawLine(img_Geist_blau[h], 0,k,3,k);
                drawLine(img_Geist_blau[h], 5,k,8,k);
                drawLine(img_Geist_blau[h], 10,k,13,k);
                k++;
                drawLine(img_Geist_blau[h], 1,k,2,k);
                drawLine(img_Geist_blau[h], 6,k,7,k);
                drawLine(img_Geist_blau[h], 11,k,12,k);
                break;
            }
            
            img_Geist_blau[h].setColor(new Color(255, 255, 255));
            k=5;
            drawLine(img_Geist_blau[h], 4,k,5,k); drawLine(img_Geist_blau[h], 8,k,9,k); k++;
            drawLine(img_Geist_blau[h], 4,k,5,k); drawLine(img_Geist_blau[h], 8,k,9,k); k++; k++; k++;
            drawLine(img_Geist_blau[h], 2,k,3,k); drawLine(img_Geist_blau[h], 6,k,7,k); drawLine(img_Geist_blau[h], 10,k,11,k); k++;
            drawLine(img_Geist_blau[h], 1,k,1,k); drawLine(img_Geist_blau[h], 4,k,5,k); drawLine(img_Geist_blau[h], 8,k,9,k); drawLine(img_Geist_blau[h], 12,k,12,k);
        }
        
        
        //Geist tot, nur Augen
        for (int i=0; i<img_Geist_tot.length; i++)
        {
            k = 0;
            img_Geist_tot[i] = new GreenfootImage(14*sizeFactor,14*sizeFactor);
            
            img_Geist_tot[i].setColor(new Color(222, 222, 255)); //weiß
            switch (i) //Augen verschieden
            {
                case 0: //nach rechts
                k = 3;
                drawLine(img_Geist_tot[i], 4,k,5,k); drawLine(img_Geist_tot[i], 10,k,11,k); k++;
                drawLine(img_Geist_tot[i], 3,k,6,k); drawLine(img_Geist_tot[i], 9,k,12,k); k++;
                drawLine(img_Geist_tot[i], 3,k,6,k); drawLine(img_Geist_tot[i], 9,k,12,k); k++;
                drawLine(img_Geist_tot[i], 3,k,6,k); drawLine(img_Geist_tot[i], 9,k,12,k); k++;
                drawLine(img_Geist_tot[i], 4,k,5,k); drawLine(img_Geist_tot[i], 10,k,11,k);
                img_Geist_tot[i].setColor(new Color(33, 33, 255)); //blau
                k=5;
                drawLine(img_Geist_tot[i], 5,k,6,k); drawLine(img_Geist_tot[i], 11,k,12,k); k++;
                drawLine(img_Geist_tot[i], 5,k,6,k); drawLine(img_Geist_tot[i], 11,k,12,k);
                break;
                
                
                case 1: //nach unten
                k = 4;
                drawLine(img_Geist_tot[i], 3,k,4,k); drawLine(img_Geist_tot[i], 9,k,10,k); k++;
                drawLine(img_Geist_tot[i], 2,k,5,k); drawLine(img_Geist_tot[i], 8,k,11,k); k++;
                drawLine(img_Geist_tot[i], 2,k,5,k); drawLine(img_Geist_tot[i], 8,k,11,k); k++;
                drawLine(img_Geist_tot[i], 2,k,5,k); drawLine(img_Geist_tot[i], 8,k,11,k); k++;
                drawLine(img_Geist_tot[i], 3,k,4,k); drawLine(img_Geist_tot[i], 9,k,10,k);
                img_Geist_tot[i].setColor(new Color(33, 33, 255)); //blau
                k = 7;
                drawLine(img_Geist_tot[i], 3,k,4,k); drawLine(img_Geist_tot[i], 9,k,10,k); k++;
                drawLine(img_Geist_tot[i], 3,k,4,k); drawLine(img_Geist_tot[i], 9,k,10,k);
                break;
                
                
                case 2: //nach links
                k = 3;
                drawLine(img_Geist_tot[i], 2,k,3,k); drawLine(img_Geist_tot[i], 8,k,9,k); k++;
                drawLine(img_Geist_tot[i], 1,k,4,k); drawLine(img_Geist_tot[i], 7,k,10,k); k++;
                drawLine(img_Geist_tot[i], 1,k,4,k); drawLine(img_Geist_tot[i], 7,k,10,k); k++;
                drawLine(img_Geist_tot[i], 1,k,4,k); drawLine(img_Geist_tot[i], 7,k,10,k); k++;
                drawLine(img_Geist_tot[i], 2,k,3,k); drawLine(img_Geist_tot[i], 8,k,9,k); k++;
                img_Geist_tot[i].setColor(new Color(33, 33, 255)); //blau
                k = 5;
                drawLine(img_Geist_tot[i], 1,k,2,k); drawLine(img_Geist_tot[i], 7,k,8,k); k++;
                drawLine(img_Geist_tot[i], 1,k,2,k); drawLine(img_Geist_tot[i], 7,k,8,k);
                break;
                
                
                case 3: //nach oben
                k = 1;
                drawLine(img_Geist_tot[i], 3,k,4,k); drawLine(img_Geist_tot[i], 9,k,10,k); k++;
                drawLine(img_Geist_tot[i], 2,k,5,k); drawLine(img_Geist_tot[i], 8,k,11,k); k++;
                drawLine(img_Geist_tot[i], 2,k,5,k); drawLine(img_Geist_tot[i], 8,k,11,k); k++;
                drawLine(img_Geist_tot[i], 2,k,5,k); drawLine(img_Geist_tot[i], 8,k,11,k); k++;
                drawLine(img_Geist_tot[i], 3,k,4,k); drawLine(img_Geist_tot[i], 9,k,10,k);
                img_Geist_tot[i].setColor(new Color(33, 33, 255)); //blau
                k = 1;
                drawLine(img_Geist_tot[i], 3,k,4,k); drawLine(img_Geist_tot[i], 9,k,10,k); k++;
                drawLine(img_Geist_tot[i], 3,k,4,k); drawLine(img_Geist_tot[i], 9,k,10,k);
                break;
            }
        }
        
        
        
        
        //Früchte
        for (int i=0; i<img_Frucht.length; i++)
        {
            img_Frucht[i] = new GreenfootImage(12*sizeFactor, 14*sizeFactor);
            //img_Frucht[i].setColor(Color.WHITE);
            //img_Frucht[i].fill();
        }
        
        //Kirsche
        img_Frucht[0].setColor(new Color(222, 151, 71)); //Stielfarbe
        k=2;
        drawLine(img_Frucht[0], 10,k,11,k); k++;
        drawLine(img_Frucht[0], 8,k,11,k); k++;
        drawLine(img_Frucht[0], 6,k,7,k); drawLine(img_Frucht[0], 9,k,9,k); k++;
        drawLine(img_Frucht[0], 5,k,5,k); drawLine(img_Frucht[0], 9,k,9,k); k++;
        drawLine(img_Frucht[0], 4,k,4,k); drawLine(img_Frucht[0], 8,k,8,k); k++;
        drawLine(img_Frucht[0], 3,k,3,k); drawLine(img_Frucht[0], 7,k,7,k); k++;
        drawLine(img_Frucht[0], 7,k,7,k+1);
        
        img_Frucht[0].setColor(new Color(222, 222, 222)); //weiß
        k=9;
        drawLine(img_Frucht[0], 1,k,2,k+1); k++; k++;
        drawLine(img_Frucht[0], 6,k,7,k+1);
        
        img_Frucht[0].setColor(new Color(255,0,0)); //rot
        k=6;
        drawLine(img_Frucht[0], 1,k,3,k); k++;
        drawLine(img_Frucht[0], 0,k,2,k); drawLine(img_Frucht[0], 4,k,5,k); k++;
        drawLine(img_Frucht[0], 0,k,4,k); drawLine(img_Frucht[0], 6,k,6,k); drawLine(img_Frucht[0], 8,k,9,k); k++;
        drawLine(img_Frucht[0], 0,k,0,k); drawLine(img_Frucht[0], 2,k,3,k); drawLine(img_Frucht[0], 5,k,6,k); drawLine(img_Frucht[0], 8,k,10,k); k++;
        drawLine(img_Frucht[0], 0,k,1,k); drawLine(img_Frucht[0], 3,k,3,k); drawLine(img_Frucht[0], 5,k,10,k); k++;
        drawLine(img_Frucht[0], 1,k,3,k); drawLine(img_Frucht[0], 5,k,5,k); drawLine(img_Frucht[0], 7,k,10,k); k++;
        drawLine(img_Frucht[0], 5,k,6,k); drawLine(img_Frucht[0], 8,k,10,k); k++;
        drawLine(img_Frucht[0], 6,k,9,k); k++;
        
        
        //Erdbeere
        c = new Color(222, 222, 255);
        img_Frucht[1].setColor(c); //weiß
        k=2;
        drawLine(img_Frucht[1], 5,k,5,k+1); k++; k++; k++;
        setColorAt(img_Frucht[1], 9,k,c); k++;
        setColorAt(img_Frucht[1], 1,k,c); setColorAt(img_Frucht[1], 7,k,c); k++;
        setColorAt(img_Frucht[1], 3,k,c); setColorAt(img_Frucht[1], 5,k,c); k++;
        setColorAt(img_Frucht[1], 8,k,c); k++;
        setColorAt(img_Frucht[1], 2,k,c); setColorAt(img_Frucht[1], 5,k,c); k++; k++;
        setColorAt(img_Frucht[1], 4,k,c); setColorAt(img_Frucht[1], 7,k,c); k++;
        
        img_Frucht[1].setColor(new Color(0,255,0)); //grün
        k=3;
        drawLine(img_Frucht[1], 2,k,4,k); drawLine(img_Frucht[1], 6,k,8,k); k++;
        drawLine(img_Frucht[1], 3,k,7,k); k++;
        drawLine(img_Frucht[1], 5,k,5,k);
        
        img_Frucht[1].setColor(new Color(255,0,0)); //rot
        k=4;
        drawLine(img_Frucht[1], 1,k,2,k); drawLine(img_Frucht[1], 8,k,9,k); k++;
        drawLine(img_Frucht[1], 0,k,4,k); drawLine(img_Frucht[1], 6,k,8,k); drawLine(img_Frucht[1], 10,k,10,k); k++;
        drawLine(img_Frucht[1], 0,k,0,k); drawLine(img_Frucht[1], 2,k,6,k); drawLine(img_Frucht[1], 8,k,10,k); k++;
        drawLine(img_Frucht[1], 0,k,2,k); drawLine(img_Frucht[1], 4,k,4,k); drawLine(img_Frucht[1], 6,k,10,k); k++;
        drawLine(img_Frucht[1], 0,k,7,k); drawLine(img_Frucht[1], 9,k,10,k); k++;
        drawLine(img_Frucht[1], 1,k,1,k); drawLine(img_Frucht[1], 3,k,4,k); drawLine(img_Frucht[1], 6,k,9,k); k++;
        drawLine(img_Frucht[1], 1,k,9,k); k++;
        drawLine(img_Frucht[1], 2,k,3,k); drawLine(img_Frucht[1], 5,k,6,k); k++;
        drawLine(img_Frucht[1], 3,k,7,k); k++;
        drawLine(img_Frucht[1], 5,k,5,k);
        
        
        //Pfirsich
        img_Frucht[2].setColor(new Color(222, 151, 71)); //Stielfarbe
        drawLine(img_Frucht[2], 5,3,5,6);
        drawLine(img_Frucht[2], 4,5,6,5);
        
        img_Frucht[2].setColor(new Color(0,255,0)); //grün
        k=2;
        drawLine(img_Frucht[2], 7,k,8,k); k++;
        drawLine(img_Frucht[2], 6,k,10,k); k++;
        drawLine(img_Frucht[2], 7,k,9,k); k++;
        
        img_Frucht[2].setColor(new Color(254, 184, 71)); //Traubenfarbe -- ocker
        drawLine(img_Frucht[2], 2,k,3,k); drawLine(img_Frucht[2], 7,k,9,k); k++;
        drawLine(img_Frucht[2], 1,k,4,k); drawLine(img_Frucht[2], 6,k,10,k); k++;
        drawLine(img_Frucht[2], 0,k,11,k); k++;
        drawLine(img_Frucht[2], 0,k,11,k); k++;
        drawLine(img_Frucht[2], 0,k,11,k); k++;
        drawLine(img_Frucht[2], 0,k,11,k); k++;
        drawLine(img_Frucht[2], 1,k,10,k); k++;
        drawLine(img_Frucht[2], 1,k,10,k); k++;
        drawLine(img_Frucht[2], 2,k,9,k); k++;
        
        //Apfel
        img_Frucht[3].setColor(new Color(222, 151, 71)); //Stielfarbe
        k=2;
        drawLine(img_Frucht[3], 6,k,6,k); k++;
        drawLine(img_Frucht[3], 5,k,5,k+1);
        
        img_Frucht[3].setColor(new Color(255,0,0)); //rot
        drawLine(img_Frucht[3], 1,k,3,k); drawLine(img_Frucht[3], 7,k,9,k); k++;
        drawLine(img_Frucht[3], 0,k,4,k); drawLine(img_Frucht[3], 6,k,10,k); k++;
        drawLine(img_Frucht[3], 0,k,11,k); k++;
        drawLine(img_Frucht[3], 0,k,11,k); k++;
        drawLine(img_Frucht[3], 0,k,11,k); k++;
        drawLine(img_Frucht[3], 0,k,8,k); drawLine(img_Frucht[3], 10,k,11,k); k++;
        drawLine(img_Frucht[3], 0,k,8,k); drawLine(img_Frucht[3], 10,k,11,k); k++;
        drawLine(img_Frucht[3], 1,k,7,k); drawLine(img_Frucht[3], 9,k,10,k); k++;
        drawLine(img_Frucht[3], 1,k,10,k); k++;
        drawLine(img_Frucht[3], 2,k,9,k); k++;
        drawLine(img_Frucht[3], 3,k,4,k); drawLine(img_Frucht[3], 6,k,8,k);k++;
        
        k=8;
        setColorAt(img_Frucht[3], 9,k,c); k++;
        setColorAt(img_Frucht[3], 9,k,c); k++;
        setColorAt(img_Frucht[3], 8,k,c);
        
        
        //Trauben
        img_Frucht[4].setColor(new Color(0, 255, 0)); //hellgrün
        k=3;
        drawLine(img_Frucht[4], 4,k,6,k); k++;
        drawLine(img_Frucht[4], 2,k,8,k); k++;
        drawLine(img_Frucht[4], 1,k,9,k); k++;
        drawLine(img_Frucht[4], 1,k,9,k); k++;
        drawLine(img_Frucht[4], 0,k,10,k); k++;
        drawLine(img_Frucht[4], 0,k,10,k); k++;
        drawLine(img_Frucht[4], 0,k,10,k); k++;
        drawLine(img_Frucht[4], 1,k,9,k); k++;
        drawLine(img_Frucht[4], 1,k,9,k); k++;
        drawLine(img_Frucht[4], 2,k,8,k); k++;
        drawLine(img_Frucht[4], 4,k,6,k);
        
        
        
        c = new Color(0, 255, 255); //hellblau
        img_Frucht[4].setColor(c);
        k=0;
        setColorAt(img_Frucht[4], 2,k,c); k++;
        drawLine(img_Frucht[4], 3,k,7,k); k++;
        setColorAt(img_Frucht[4], 5,k,c); k++; k++;
        setColorAt(img_Frucht[4], 5,k,c); k++;
        setColorAt(img_Frucht[4], 2,k,c); setColorAt(img_Frucht[4], 4,k,c); setColorAt(img_Frucht[4], 8,k,c); k++;
        setColorAt(img_Frucht[4], 3,k,c); setColorAt(img_Frucht[4], 7,k,c); k++;
        setColorAt(img_Frucht[4], 2,k,c); setColorAt(img_Frucht[4], 6,k,c); setColorAt(img_Frucht[4], 8,k,c); k++;
        setColorAt(img_Frucht[4], 1,k,c); setColorAt(img_Frucht[4], 5,k,c); setColorAt(img_Frucht[4], 9,k,c); k++;
        setColorAt(img_Frucht[4], 2,k,c); setColorAt(img_Frucht[4], 6,k,c); k++;
        setColorAt(img_Frucht[4], 3,k,c); setColorAt(img_Frucht[4], 5,k,c); setColorAt(img_Frucht[4], 7,k,c); k++;
        setColorAt(img_Frucht[4], 4,k,c); setColorAt(img_Frucht[4], 8,k,c); k++;
        setColorAt(img_Frucht[4], 3,k,c); setColorAt(img_Frucht[4], 7,k,c); k++;
        setColorAt(img_Frucht[4], 6,k,c); k++;
        
        c = new Color(255, 0, 0); //rot
        k=3;
        setColorAt(img_Frucht[4], 5,k,c); k++; k++;
        setColorAt(img_Frucht[4], 3,k,c); k++;
        setColorAt(img_Frucht[4], 6,k,c); k++;
        setColorAt(img_Frucht[4], 1,k,c); k++;
        setColorAt(img_Frucht[4], 4,k,c); setColorAt(img_Frucht[4], 8,k,c); k++;
        setColorAt(img_Frucht[4], 1,k,c); k++;
        setColorAt(img_Frucht[4], 4,k,c); setColorAt(img_Frucht[4], 6,k,c);
        
        
        //Galaxian
        img_Frucht[5].setColor(new Color(255, 255, 0)); //gelb
        k=6;
        drawLine(img_Frucht[5], 1,k,9,k); k++;
        drawLine(img_Frucht[5], 1,k,9,k); k++;
        drawLine(img_Frucht[5], 2,k,8,k); k++;
        drawLine(img_Frucht[5], 3,k,3,k); drawLine(img_Frucht[5], 5,k,5,k+4); drawLine(img_Frucht[5], 7,k,7,k);
        
        img_Frucht[5].setColor(new Color(255, 0, 0)); //rot
        k=3;
        drawLine(img_Frucht[5], 5,k,5,k+4); k++;
        drawLine(img_Frucht[5], 4,k,6,k); k++;
        drawLine(img_Frucht[5], 3,k,7,k); k++;
        drawLine(img_Frucht[5], 2,k,3,k); drawLine(img_Frucht[5], 7,k,8,k); k++;
        
        img_Frucht[5].setColor(new Color(0, 0, 255)); //blau
        k=0; //Spalte
        drawLine(img_Frucht[5], k,4,k,8); k++;
        drawLine(img_Frucht[5], k,8,k,9); k++;
        drawLine(img_Frucht[5], k,9,k,10); k++;
        drawLine(img_Frucht[5], k,10,k,11); k++; k++; k++; k++;
        drawLine(img_Frucht[5], k,10,k,11); k++;
        drawLine(img_Frucht[5], k,9,k,10); k++;
        drawLine(img_Frucht[5], k,8,k,9); k++;
        drawLine(img_Frucht[5], k,4,k,8); k++;
        
        
        //Glocke
        img_Frucht[6].setColor(new Color(255, 255, 0)); //gelb
        k=1;
        drawLine(img_Frucht[6], 4,k,7,k); k++;
        drawLine(img_Frucht[6], 3,k,4,k); drawLine(img_Frucht[6], 7,k,8,k); k++;
        drawLine(img_Frucht[6], 2,k,9,k); k++;
        drawLine(img_Frucht[6], 2,k,9,k); k++;
        drawLine(img_Frucht[6], 2,k,9,k); k++;
        drawLine(img_Frucht[6], 1,k,10,k); k++;
        drawLine(img_Frucht[6], 1,k,10,k); k++;
        drawLine(img_Frucht[6], 1,k,10,k); k++;
        drawLine(img_Frucht[6], 0,k,11,k); k++;
        drawLine(img_Frucht[6], 0,k,11,k); k++;
        drawLine(img_Frucht[6], 0,k,11,k); k++;
        drawLine(img_Frucht[6], 0,k,11,k);
        
        img_Frucht[6].setColor(new Color(0, 0, 0)); //schwarz
        drawLine(img_Frucht[6], 4,4,4,4);
        drawLine(img_Frucht[6], 3,5,3,7);
        drawLine(img_Frucht[6], 2,9,2,10);
        
        img_Frucht[6].setColor(new Color(0, 255, 255)); //hellblau
        k=12;
        drawLine(img_Frucht[6], 1,k,10,k); k++;
        drawLine(img_Frucht[6], 1,k,10,k);
        
        img_Frucht[6].setColor(new Color(222, 222, 255)); //weiß
        k=12;
        drawLine(img_Frucht[6], 6,k,7,k); k++;
        drawLine(img_Frucht[6], 6,k,7,k);
        
        
        //Schlüssel
        img_Frucht[7].setColor(new Color(0, 255, 255)); //hellblau
        k=1;
        drawLine(img_Frucht[7], 4,k,6,k); k++;
        drawLine(img_Frucht[7], 2,k,3,k); drawLine(img_Frucht[7], 7,k,8,k); k++;
        drawLine(img_Frucht[7], 2,k,8,k); k++;
        drawLine(img_Frucht[7], 2,k,8,k); k++;
        drawLine(img_Frucht[7], 2,k,8,k); k++;
        
        c = new Color(222, 222, 255); //weiß
        img_Frucht[7].setColor(c);
        drawLine(img_Frucht[7], 4,k,4,k+6); drawLine(img_Frucht[7], 6,k,6,k+2); k++;
        setColorAt(img_Frucht[7], 7,k,c); k++; k++; k++;
        drawLine(img_Frucht[7], 6,k,6,k+2); k++;
        setColorAt(img_Frucht[7], 7,k,c); k++; k++;
        setColorAt(img_Frucht[7], 5,k,c);
        
        
        
        
        
        
        
        lastSize = sizeFactor;
    }
    
    private void f(GreenfootImage img, int x, int y, Color c) {img.setColorAt(x,y,c);}
    
    private void createMap()
    {
        for (int y=0; y<map.length; y++) for (int x=0; x<map[0].length; x++)
        {
            int m = map[y][x];
            if (m==0) continue;
            Actor actor = null;
            if (m==2) actor = new Punkt(true);
            else if (m==3) actor = new Punkt(false);
            
            if (actor != null) addObject(actor, 4+x*8, 4+y*8);
        }
    }
    
    public static void drawLine(GreenfootImage img, int x1, int y1, int x2, int y2)
    {
        img.fillRect(x1*sizeFactor, y1*sizeFactor, (x2-x1+1)*sizeFactor, (y2-y1+1)*sizeFactor);
    }
    
    public static void fillRect(GreenfootImage img, int x1, int y1, int x2, int y2)
    {
        img.fillRect(x1*sizeFactor, y1*sizeFactor, x2*sizeFactor, y2*sizeFactor);
    }
    
    public static void setColorAt(GreenfootImage img, int x1, int y1, Color c)
    {
        for (int i=0; i<sizeFactor; i++) for (int j=0; j<sizeFactor; j++)
        {
            img.setColorAt(x1*sizeFactor+i, y1*sizeFactor+j, c);
        }
    }
    
    public static int getFPS() {return fpsFactor;}
}